/*
   News Peruser Copyright (c) 1996, 1997 James Bailie
   ==================================================================
   
   News Peruser is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   News Peruser is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   General Public License for more details.

   Although News Peruser is licensed under the Free Software
   Foundation's GNU General Public License, Peruser is not produced
   by, nor is it endorsed by the Free Software Foundation. The Free
   Software Foundation is not responsible for developing,
   distributing, or supporting Peruser in any way. Anyone may place
   software they own the copyright to, under the GNU General Public
   License.

   The GNU General Public License is included in the News Peruser 
   distribution archive in a file called COPYING. If you do
   not have a copy of the license, you can download one from
   ftp://prep.ai.mit.edu, or you can write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

   =====================================================================
*/

#include "peruser_includes.h"

void run_client_program();
void refresh_newsgroups();
void update_read_file();

void hear_callback( FL_OBJECT *obj, long caller )
{
  static int hear_articles_requested;
  static enum{ no, yes } header = no;

  switch( caller )
    {

/*
   fd_hear->all_button.
*/

    case 1:
      hear_articles_requested = -1;
      break;
      
/*
   fd_hear->none_button.
*/

    case 2:
      hear_articles_requested = 0;
      break;

/*
   fd_hear->specific_button.
*/

    case 3:

/*
   fd_hear->article_counter.
*/

    case 4:
      fl_set_button( fd_hear->specific_button, 1 );
      fl_set_button( fd_hear->all_button, 0 );
      fl_set_button( fd_hear->none_button, 0 );
      fl_set_button( fd_hear->headers_button, 0 );
      fl_set_button( fd_hear->full_button, 0 );
      hear_articles_requested =
	fl_get_counter_value( fd_hear->article_counter );
      break;

/*
   fd_hear->cancel_button.
*/

    case 5:
      fl_hide_form( fd_hear->hear );
      hear_onscreen = no;
      break;

/*
   fd_peruser->hear_button.
*/

    case 6:
      if ( hear_onscreen )
          fl_raise_form( fd_hear->hear );
      else
      {
          fl_set_button( fd_hear->all_button, 0 );
          fl_set_button( fd_hear->none_button, 0 );
          fl_set_button( fd_hear->specific_button, 0 );
          fl_set_button( fd_hear->headers_button, 1 );
          fl_set_button( fd_hear->full_button, 0 );
          fl_set_button( fd_hear->last_article_button, 1 );
          fl_set_button( fd_hear->last_header_button, 0 );
          hear_articles_requested = -2;

          fl_show_form( fd_hear->hear, FL_PLACE_MOUSE, FL_FULLBORDER, 
                        "Hear" );
          hear_onscreen = yes;
      }
      break;

/*
   fd_hear->hear_button.
*/

    case 7:
      fl_clear_browser( fd_regex->regex_browser );

      if ( authenticating )
	if ( nntp_username[ 0 ] == '\0' || 
	     nntp_password[ 0 ] == '\0' ||
	     !strcmp( nntp_username, "none" ) ||
	     !strcmp( nntp_password, "none" ))
	  {
	    fl_show_alert( "Error:", 
			   "You have not filled-in your authenication",
			   "information on the configure form.", 0 );

	    fl_call_object_callback( fd_peruser->configure_button );
	    return;
	  }

      sprintf( line_buffer, "chearer %s %s %s %s", server_address, 
	       authenticating ? "-a" : " ",
	       authenticating ? nntp_username : " ",
	       authenticating ? nntp_password : " " );

      switch ( hear_articles_requested )
	{
	case -3:
	  strcat( line_buffer, " requests" );
	  break;
	case -2:
	  strcat( line_buffer, " headers" );
	  break;
	case -1:
	  break;
	
	default:
	  if ( header )
	    {
	      sprintf( second_line_buffer, "%s %d headers", 
		       line_buffer, hear_articles_requested );
	      memcpy( line_buffer, second_line_buffer, BUFFER_SIZE );
	    }
	  else
	    {
	      sprintf( second_line_buffer, "%s %d", 
		       line_buffer, hear_articles_requested );
	      memcpy( line_buffer, second_line_buffer, BUFFER_SIZE );
	    }
	  break;
	}
      
      strcpy( second_line_buffer, line_buffer );

      update_read_file();

      fl_hide_form( fd_hear->hear );
      hear_onscreen = no;
      
      run_client_program();
      
      article_count = 0;
      refresh_newsgroups();
      break;

/*
  fd_hear->headers_button.
*/

    case 10:
      hear_articles_requested = -2;
      break;

/*
  fd_hear->full_button.
*/

    case 11:
      hear_articles_requested = -3;
      break;

/*
  fd_hear->last_article_button.
*/

    case 20:
      header = no;
      break;

/*
  fd_hear->last_header_button.
*/

    case 21:
      header = yes;
      break;
    }
  return;
}


