/*
   ==================================================================
   
   News Peruser Copyright (c) 1996, James Bailie
   
   News Peruser is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   News Peruser is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   General Public License for more details.

   Although News Peruser is licensed under the Free Software
   Foundation's GNU General Public License, Peruser is not produced
   by, nor is it endorsed by the Free Software Foundation. The Free
   Software Foundation is not responsible for developing,
   distributing, or supporting Peruser in any way. Anyone may place
   software they own the copyright to, under the GNU General Public
   License.

   The GNU General Public License is included in the News Peruser 
   distribution archive in a file called COPYING. If you do
   not have a copy of the license, you can download one from
   ftp://prep.ai.mit.edu, or you can write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

   =====================================================================
*/

#include "peruser_includes.h"

void quoter_callback( FL_OBJECT *obj, long caller )
{
  int index;
  int maximum;
  

  switch( caller )
    {

/*
   fd_quoter->quoter_cancel_button.
*/

    case 0:
      fl_hide_form( fd_quoter->quoter );
      return;
      break;

/*
   fd_quoter->quoter_done_button.
*/

    case 1:
      if (( quote_file = fopen( quote_path_and_name, "w" )) == NULL )
	{
	  perror( name );
	  exit( EXIT_FAILURE );
	}

      index = 1;
      maximum = fl_get_browser_maxline( 
		   fd_quoter->quoter_destination_browser );
      
      for( index =1; index <= maximum; index++ )
	{
	  strcpy( line_buffer, 
		  fl_get_browser_line( 
		     fd_quoter->quoter_destination_browser, index ));
	  
	  line_pointer = strtok( line_buffer, "\r" );
	  if ( line_pointer )
	    {
	      strcpy( second_line_buffer, line_pointer );
	      strcat( second_line_buffer, "\n" );
	      fputs( second_line_buffer, quote_file );
	    }
	  else
	    {
	      fputs( "\n", quote_file );
	    }
	}

      fflush( quote_file );
      fclose( quote_file );
      
      fl_hide_form( fd_quoter->quoter );

      switch( reply_by_mail )
	{
	case 0:
	  run_editor( obj, 2 );
	  break;
	case 1:
	  run_editor( obj, 22 );
	  break;
	case 2:
	  run_editor( obj, 32 );
	}

      break;

/*
   fd_quoter->quoter_source_browser.
*/

    case 2:
      strcpy( line_buffer, 
	      fl_get_browser_line( 
		 fd_quoter->quoter_source_browser,
		 fl_get_browser( fd_quoter->quoter_source_browser )));

      if ( !strncmp( line_buffer, "@C18", 4 ) ||
	   !strncmp( line_buffer, "@C22", 4 ))
	return;

      if ( line_buffer[ 0 ] == '@' )
	{
	  strcpy( second_line_buffer, line_buffer + 3 );
	  strcpy( line_buffer, second_line_buffer );
	}

      strcpy( second_line_buffer, "> " );
      strcat( second_line_buffer, line_buffer );
      fl_add_browser_line( fd_quoter->quoter_destination_browser,
			   second_line_buffer );
      break;

/*
   fd_quoter->quoter_destination_browser.
*/

    case 3:
      fl_delete_browser_line( fd_quoter->quoter_destination_browser,
			      fl_get_browser(
				 fd_quoter->quoter_destination_browser ));
      break;

/*
   fd_quoter->quoter_delete_button.
*/

    case 4:
      maximum =
	fl_get_browser_maxline( fd_quoter->quoter_destination_browser );

      if ( maximum == 2 )
	break;

      for( index = 2; index <= maximum; index++ )
	fl_delete_browser_line( fd_quoter->quoter_destination_browser, 2 );

      fl_add_browser_line( fd_quoter->quoter_destination_browser, "\r" );
      break;

/*
   fd_quoter->quoter_all_button.
*/

    case 5:
      maximum =
	fl_get_browser_maxline( fd_quoter->quoter_source_browser );
      for( index = 1; index <= maximum; index++ )
	{
	  strcpy( line_buffer, 
		  fl_get_browser_line(
		     fd_quoter->quoter_source_browser, index ));

	  if ( line_buffer[ 0 ] == '@' )
	    {
	      strcpy( second_line_buffer, line_buffer + 3  );
	      memcpy( line_buffer, second_line_buffer, BUFFER_SIZE );
	    }

	  strcpy( second_line_buffer, "> " );
	  strcat( second_line_buffer, line_buffer );
	  memcpy( line_buffer, second_line_buffer, BUFFER_SIZE );

	  fl_add_browser_line( fd_quoter->quoter_destination_browser,
			       line_buffer );
	}
      break;
    }
  return;
}








